'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RadioInputGroup = require('@instructure/ui-forms/lib/components/RadioInputGroup');

var _RadioInputGroup2 = _interopRequireDefault(_RadioInputGroup);

var _RadioInput = require('@instructure/ui-forms/lib/components/RadioInput');

var _RadioInput2 = _interopRequireDefault(_RadioInput);

var _formatMessage = require('../../../../../../common/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

var _Setting = require('../Setting');

var _Setting2 = _interopRequireDefault(_Setting);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var calcTypes = [{ value: 'basic', label: (0, _formatMessage2.default)('Basic') }, { value: 'scientific', label: (0, _formatMessage2.default)('Scientific') }];

var Calculator = (_temp2 = _class = function (_Component) {
  (0, _inherits3.default)(Calculator, _Component);

  function Calculator() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Calculator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Calculator.__proto__ || Object.getPrototypeOf(Calculator)).call.apply(_ref, [this].concat(args))), _this), _this.defaultType = 'basic', _this.toggleAllowCalculator = function (event) {
      if (_this.calculatorIsAllowed()) _this.defaultType = _this.props.calculatorType;
      var _this$props = _this.props,
          setCalculatorType = _this$props.setCalculatorType,
          activeQuizId = _this$props.activeQuizId;

      setCalculatorType(activeQuizId, event.target.checked ? _this.defaultType : 'none');
    }, _this.setAllowedCalculatorType = function (e, value) {
      var _this$props2 = _this.props,
          setCalculatorType = _this$props2.setCalculatorType,
          activeQuizId = _this$props2.activeQuizId;

      setCalculatorType(activeQuizId, value);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Calculator, [{
    key: 'calculatorIsAllowed',
    value: function calculatorIsAllowed() {
      return this.props.calculatorType !== 'none';
    }

    // =============
    //    ACTIONS
    // =============

  }, {
    key: 'render',


    // =============
    //   RENDERING
    // =============

    value: function render() {
      return _react2.default.createElement(
        _Setting2.default,
        {
          isChecked: this.calculatorIsAllowed(),
          showMore: this.calculatorIsAllowed(),
          label: (0, _formatMessage2.default)('Allow Calculator'),
          onChange: this.toggleAllowCalculator
        },
        _react2.default.createElement(
          _RadioInputGroup2.default,
          {
            name: 'calculatorOptions',
            description: (0, _formatMessage2.default)('Calculator Type'),
            value: this.props.calculatorType,
            onChange: this.setAllowedCalculatorType
          },
          calcTypes.map(function (calcType) {
            return _react2.default.createElement(_RadioInput2.default, { key: calcType.value, value: calcType.value, label: calcType.label });
          })
        )
      );
    }
  }]);
  Calculator.displayName = 'Calculator'
  ;
  return Calculator;
}(_react.Component), _class.propTypes = {
  activeQuizId: _propTypes2.default.string.isRequired,
  calculatorType: _propTypes2.default.string,
  setCalculatorType: _propTypes2.default.func.isRequired
}, _class.defaultProps = {
  calculatorType: 'none'
}, _temp2);
exports.default = Calculator;