'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react3 = require('format-message/react');

var _Alert = require('@instructure/ui-alerts/lib/components/Alert');

var _Alert2 = _interopRequireDefault(_Alert);

var _Button = require('@instructure/ui-buttons/lib/components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _CloseButton = require('@instructure/ui-buttons/lib/components/CloseButton');

var _CloseButton2 = _interopRequireDefault(_CloseButton);

var _Heading = require('@instructure/ui-elements/lib/components/Heading');

var _Heading2 = _interopRequireDefault(_Heading);

var _RadioInput = require('@instructure/ui-forms/lib/components/RadioInput');

var _RadioInput2 = _interopRequireDefault(_RadioInput);

var _RadioInputGroup = require('@instructure/ui-forms/lib/components/RadioInputGroup');

var _RadioInputGroup2 = _interopRequireDefault(_RadioInputGroup);

var _Text = require('@instructure/ui-elements/lib/components/Text');

var _Text2 = _interopRequireDefault(_Text);

var _lib = require('@instructure/ui-themeable/lib');

var _lib2 = _interopRequireDefault(_lib);

var _Modal = require('../../../common/components/Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var _constants = require('../../../constants');

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

var _formatMessage = require('../../../common/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  template: function template(theme) {
    return '/*  imported from styles.css  */\n\n.RegradingModal__styles__alert {\n  padding-bottom: ' + theme.alertBottomPadding + ';\n}\n\n.RegradingModal__styles__radioInputGroup {\n  padding-bottom: ' + theme.radioInputGroupBottomPadding + ';\n}\n\n.RegradingModal__styles__select {\n  padding: 0 1.6rem ' + theme.selectPadding + ';\n}\n';
  },
  'alert': 'RegradingModal__styles__alert',
  'radioInputGroup': 'RegradingModal__styles__radioInputGroup',
  'select': 'RegradingModal__styles__select'
};
var RegradingModal = (_dec = (0, _lib2.default)(_theme2.default, styles), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(RegradingModal, _Component);

  function RegradingModal() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, RegradingModal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = RegradingModal.__proto__ || Object.getPrototypeOf(RegradingModal)).call.apply(_ref, [this].concat(args))), _this), _this.cancelAction = function () {
      _this.props.closeModal();
    }, _this.onSpeedgraderOptionChange = function (event, newValue) {
      _this.props.setScoreReconciliation(newValue);
    }, _this.onSubmit = function () {
      var _this$props = _this.props,
          createQuizEntryRegrade = _this$props.createQuizEntryRegrade,
          quizId = _this$props.quizId,
          regradingPayload = _this$props.regradingPayload,
          scoreReconciliation = _this$props.scoreReconciliation;


      createQuizEntryRegrade(quizId, Object.assign({}, regradingPayload, { scoreReconciliation: scoreReconciliation })).then(function () {
        _this.props.toggleRegradingEditMode('');
        _this.props.addSuccess('\u062A\u0645 \u062C\u062F\u0648\u0644\u0629 \u0625\u0639\u0627\u062F\u0629 \u0627\u0644\u062A\u0642\u064A\u064A\u0645 \u0628\u0646\u062C\u0627\u062D\u060C \u062A\u062D\u0642\u0642 \u0644\u0627\u062D\u0642\u064B\u0627 \u0644\u062A\u062A\u0623\u0643\u062F \u0645\u0646 \u062A\u0637\u0628\u064A\u0642\u0647\u0627.');
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(RegradingModal, [{
    key: 'cancelButton',


    // Rendering

    value: function cancelButton() {
      return _react2.default.createElement(
        _Button2.default,
        {
          margin: _constants.XSMALL_SIDE_MARGIN,
          onClick: this.cancelAction,
          ref: this.setRef('cancelImportButton')
        },
        '\u0625\u0644\u063A\u0627\u0621'
      );
    }
  }, {
    key: 'regradeButton',
    value: function regradeButton() {
      return _react2.default.createElement(
        _Button2.default,
        {
          margin: _constants.XSMALL_SIDE_MARGIN,
          onClick: this.onSubmit,
          ref: this.setRef('confirmButton'),
          variant: 'primary',
          'data-automation': 'sdk-regrade-button'
        },
        '\u0625\u0639\u0627\u062F\u0629 \u062A\u0642\u064A\u064A\u0645 \u0627\u0644\u062F\u0631\u062C\u0629'
      );
    }
  }, {
    key: 'setRef',
    value: function setRef(refName) {
      var _this2 = this;

      return function (node) {
        _this2[refName] = node;
      };
    }
  }, {
    key: 'renderOptionInputs',
    value: function renderOptionInputs() {
      return Object.entries(this.optionInputs).map(function (optionInput) {
        return _react2.default.createElement(
          'option',
          { key: optionInput[0], value: optionInput[0] },
          optionInput[1].text
        );
      });
    }
  }, {
    key: 'renderRadioInputs',
    value: function renderRadioInputs() {
      return Object.entries(this.optionInputs).map(function (optionInput) {
        return _react2.default.createElement(_RadioInput2.default, {
          label: optionInput[1].text,
          value: optionInput[0],
          key: optionInput[0]
        });
      });
    }
  }, {
    key: 'renderModalBody',
    value: function renderModalBody() {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _Alert2.default,
          {
            margin: 'small 0',
            transition: 'none',
            variant: 'info'
          },
          _react2.default.createElement(
            'div',
            { className: styles.alert },
            _react2.default.createElement(
              'p',
              null,
              (0, _react3.formatChildren)('\n                  <0>\u062A\u0646\u0637\u0628\u0642 \u0625\u0639\u0627\u062F\u0629 \u0627\u0644\u062A\u0642\u064A\u064A\u0645 \u0641\u0642\u0637 \u0639\u0644\u0649 \u0627\u0644\u0625\u0631\u0633\u0627\u0644\u0627\u062A \u0627\u0644\u0645\u0643\u062A\u0645\u0644\u0629.</0>\n                  <1>\u0625\u0630\u0627 \u062A\u0623\u062B\u0631 \u062C\u0645\u064A\u0639 \u0627\u0644\u0637\u0644\u0627\u0628\u060C \u064A\u064F\u0631\u062C\u0649 \u0627\u0646\u062A\u0638\u0627\u0631 \u0643\u0627\u0641\u0629 \u0627\u0644\u0625\u0631\u0633\u0627\u0644\u0627\u062A \u0642\u0628\u0644 \u0625\u0639\u0627\u062F\u0629 \u0627\u0644\u062A\u0642\u064A\u064A\u0645.</1>\n                ', [_react2.default.createElement(_Text2.default, { as: 'div', weight: 'bold', key: '0' }), _react2.default.createElement(_Text2.default, { as: 'span', key: '1' })])
            )
          )
        ),
        _react2.default.createElement(
          'form',
          null,
          _react2.default.createElement(
            'div',
            { className: styles.radioInputGroup },
            _react2.default.createElement(
              _RadioInputGroup2.default,
              {
                description: '\u062D\u062F\u062F \u0627\u0644\u0637\u0631\u064A\u0642\u0629 \u0627\u0644\u062A\u064A \u062A\u0631\u063A\u0628 \u0641\u064A\u0647\u0627 \u062A\u0637\u0628\u064A\u0642 \u0625\u0639\u0627\u062F\u0629 \u062A\u0642\u064A\u064A\u0645 \u0627\u0644\u062F\u0631\u062C\u0629 \u0647\u0630\u0647.',
                name: 'scoring_reconciliation',
                onChange: this.onSpeedgraderOptionChange,
                messages: this.selectHint,
                value: this.scoreReconciliation
              },
              this.renderRadioInputs()
            )
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _Modal2.default,
        {
          open: this.props.modalOpen,
          size: 'medium',
          onDismiss: this.cancelAction,
          label: '\u062E\u064A\u0627\u0631\u0627\u062A \u0625\u0639\u0627\u062F\u0629 \u062A\u0642\u064A\u064A\u0645 \u062F\u0631\u062C\u0629 \u0627\u0644\u0639\u0646\u0635\u0631',
          ref: this.setRef('modal'),
          'data-automation': 'sdk-regrade-modal',
          shouldCloseOnDocumentClick: false
        },
        _react2.default.createElement(
          _Modal.ModalHeader,
          null,
          _react2.default.createElement(
            _Heading2.default,
            { level: 'reset', as: 'h2' },
            '\u062E\u064A\u0627\u0631\u0627\u062A \u0625\u0639\u0627\u062F\u0629 \u062A\u0642\u064A\u064A\u0645 \u062F\u0631\u062C\u0629 \u0627\u0644\u0639\u0646\u0635\u0631'
          ),
          _react2.default.createElement(_CloseButton2.default, {
            onClick: this.cancelAction,
            placement: 'end',
            offset: 'medium',
            variant: 'icon'
          })
        ),
        _react2.default.createElement(
          _Modal.ModalBody,
          null,
          this.renderModalBody()
        ),
        _react2.default.createElement(
          _Modal.ModalFooter,
          null,
          this.cancelButton(),
          this.regradeButton()
        )
      );
    }
  }, {
    key: 'optionInputs',


    // Getters
    get: function get() {
      return {
        new_score: {
          hint: '\u0642\u062F \u064A\u062A\u0645 \u062A\u0642\u0644\u064A\u0644 \u0628\u0639\u0636 \u0627\u0644\u0646\u062A\u0627\u0626\u062C\u060C \u0648\u0628\u0639\u0636\u0647\u0627 \u0642\u062F \u064A\u062A\u0645 \u0631\u0641\u0639\u0647',
          text: '\u0645\u0646\u062D \u0627\u0644\u0646\u0642\u0627\u0637 \u0644\u0644\u0625\u062C\u0627\u0628\u0629 \u0627\u0644\u0635\u062D\u064A\u062D\u0629 \u0641\u0642\u0637'
        },
        old_score: {
          hint: '\u0644\u0646 \u064A\u062A\u0645 \u062A\u062E\u0641\u064A\u0636 \u0623\u064A \u062F\u0631\u062C\u0627\u062A',
          text: '\u064A\u0645\u0646\u062D \u0646\u0642\u0627\u0637\u064B\u0627 \u0644\u0643\u0644\u064D \u0645\u0646 \u0627\u0644\u0625\u062C\u0627\u0628\u0627\u062A \u0627\u0644\u062D\u0627\u0644\u064A\u0629 \u0648\u0627\u0644\u0633\u0627\u0628\u0642\u0629 \u0639\u0644\u0649 \u062D\u062F\u064D \u0633\u0648\u0627\u0621'
        },
        any_response: {
          hint: '\u062C\u0645\u064A\u0639 \u0645\u0646 \u064A\u062C\u064A\u0628 \u064A\u062D\u0635\u0644 \u0639\u0644\u0649 \u0631\u0635\u064A\u062F \u0643\u0627\u0645\u0644',
          text: '\u064A\u0645\u0646\u062D \u0646\u0642\u0627\u0637\u064B\u0627 \u0644\u0623\u064A \u0625\u062C\u0627\u0628\u0629 \u0645\u0631\u0633\u0644\u0629'
        },
        thrown_out: {
          hint: '\u062A\u0645 \u0627\u0633\u062A\u0628\u0639\u0627\u062F \u0627\u0644\u0633\u0624\u0627\u0644',
          text: '\u064A\u0645\u0646\u062D \u0627\u0644\u062C\u0645\u064A\u0639 \u0631\u0635\u064A\u062F\u064B\u0627 \u0643\u0627\u0645\u0644\u0627\u064B'
        }
      };
    }
  }, {
    key: 'scoreReconciliation',
    get: function get() {
      return this.props.scoreReconciliation;
    }
  }, {
    key: 'selectHint',
    get: function get() {
      var hint = this.optionInputs[this.scoreReconciliation].hint;
      return [{
        text: '\u0627\u0644\u0646\u062A\u064A\u062C\u0629: ' + hint,
        type: 'hint'
      }];
    }

    // Handlers

  }]);
  RegradingModal.displayName = 'RegradingModal'
  ;
  return RegradingModal;
}(_react.Component), _class2.propTypes = {
  addSuccess: _propTypes2.default.func.isRequired,
  closeModal: _propTypes2.default.func.isRequired,
  createQuizEntryRegrade: _propTypes2.default.func.isRequired,
  modalOpen: _propTypes2.default.bool.isRequired,
  quizId: _propTypes2.default.string.isRequired,
  regradingPayload: _propTypes2.default.shape({
    quizEntryId: _propTypes2.default.string.isRequired,
    scoringAlgorithm: _propTypes2.default.string,
    scoringData: _propTypes2.default.object
  }).isRequired,
  scoreReconciliation: _propTypes2.default.string.isRequired,
  setScoreReconciliation: _propTypes2.default.func.isRequired,
  toggleRegradingEditMode: _propTypes2.default.func.isRequired }, _temp2)) || _class);
exports.default = RegradingModal;