---
category: components
name: ModerateTable
---
Moderation is a feature where consumer and SDK records meet. ModerateTable
accepts an array of objects of consumer quiz taker data, then populates
itself with quiz session data.

```jsx_example
const moderateData = [{
  avatar: 'http://lorempixel.com/80/80/city',
  id: '1',
  name: 'Jim Student',
  quizSessionIds: [],
  maxAttempts: 2
}, {
  avatar: 'http://lorempixel.com/80/80/sports',
  id: '2',
  name: 'Tom Student',
  quizSessionIds: ['1'],
  maxAttempts: 2
}, {
  avatar: 'http://lorempixel.com/80/80/cats',
  id: '3',
  name: 'Bob Student',
  quizSessionIds: [],
  maxAttempts: 2
}]

class Example extends React.Component {
  render () {
    return (
      <SDKApp
        apiEndpoint={`http://${config.API_HOST}`}
        appContainer=".root"
        userToken={config.TOKEN_QUIZ_SESSIONS_LIST}
      >
        <ModerateTable
          tableData={moderateData}
          quizId="1"
          onModerateLogClick={Function.prototype}
          onResultsLinkClick={Function.prototype}
          onModerateButtonClick={Function.prototype}
        />
      </SDKApp>
    )
  }
}

<LocaleSwitcher>
  <Example />
</LocaleSwitcher>
```
