'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

var _ItemAnalysis = require('../../../../common/records/ItemAnalysis');

var _ItemAnalysis2 = _interopRequireDefault(_ItemAnalysis);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var standardItemAnalysis = new _ItemAnalysis2.default((0, _immutable.fromJS)({
  itemId: '3',
  itemAnalysis: {
    scoreInfo: {
      resultSum: 5,
      resultCount: 1
    },
    unansweredInfo: 1,
    choiceInfo: [{
      choiceCount: 2,
      id: 'id',
      itemBody: '<p>Item&gt;Body</p>',
      correct: true
    }, {
      choiceCount: 3,
      id: 'not_id',
      itemBody: 'choice Item Body not correct',
      correct: false
    }, {
      choiceCount: 4,
      id: 'not_id_again',
      itemBody: 'choice Item Body not correct still',
      correct: false
    }]
  }
}));

exports.default = {
  permutations: [],
  renderProps: function renderProps(props) {
    return {
      componentProps: {
        itemAnalysis: standardItemAnalysis
      }
    };
  }
};