'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

var _keyBy = require('lodash/keyBy');

var _keyBy2 = _interopRequireDefault(_keyBy);

var _constants = require('../../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var addSessionItemResults = function addSessionItemResults(state, sessionItemResults) {
  var sessionItemResultsHash = (0, _keyBy2.default)(sessionItemResults, 'id');
  return state.merge((0, _immutable.fromJS)(sessionItemResultsHash));
};

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _immutable.Map)();
  var action = arguments[1];

  switch (action.type) {
    case _constants.ADD_SESSION_ITEM_RESULTS:
      return addSessionItemResults(state, action.payload);
    default:
      return state;
  }
};