'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

var _keyBy = require('lodash/keyBy');

var _keyBy2 = _interopRequireDefault(_keyBy);

var _constants = require('../../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var addBankEntries = function addBankEntries(state, bankEntries) {
  return state.merge((0, _immutable.fromJS)((0, _keyBy2.default)(bankEntries, 'id')));
};

var defaultState = (0, _immutable.fromJS)({});

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
  var action = arguments[1];

  switch (action.type) {
    case _constants.ADD_BANK_ENTRIES:
      return addBankEntries(state, action.payload);
    case _constants.ARCHIVE_BANK_ENTRY:
      return state.setIn([action.payload, 'archived'], true);
    default:
      return state;
  }
};