'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

var _constants = require('../../constants');

var defaultState = (0, _immutable.fromJS)({
  contextUuid: '',
  outcomesEndpoint: '',
  outcomesToken: ''
});

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
  var action = arguments[1];

  switch (action.type) {
    case _constants.SET_CONTEXT_UUID:
      return state.set('contextUuid', action.payload);
    case _constants.SET_OUTCOMES_ENDPOINT:
      return state.set('outcomesEndpoint', action.payload);
    case _constants.SET_OUTCOMES_TOKEN:
      return state.set('outcomesToken', action.payload);
    default:
      return state;
  }
};