'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
// ===============
//     ROUTING
// ===============

var ACTIVE_BANK_CHANGE = exports.ACTIVE_BANK_CHANGE = 'ACTIVE_BANK_CHANGE';
var ACTIVE_BANK_ENTRY_CHANGE = exports.ACTIVE_BANK_ENTRY_CHANGE = 'ACTIVE_BANK_ENTRY_CHANGE';
var ACTIVE_QUIZ_CHANGE = exports.ACTIVE_QUIZ_CHANGE = 'ACTIVE_QUIZ_CHANGE';
var ACTIVE_QUIZ_SESSION_CHANGE = exports.ACTIVE_QUIZ_SESSION_CHANGE = 'ACTIVE_QUIZ_SESSION_CHANGE';
var GO_BACK = exports.GO_BACK = 'GO_BACK';
var NAVIGATE_TO = exports.NAVIGATE_TO = 'NAVIGATE_TO';
var NEW_QUIZ_ID = exports.NEW_QUIZ_ID = 'new';
var UPDATE_PATH = exports.UPDATE_PATH = 'UPDATE_PATH';
var UPDATE_RETURN_TO_URL = exports.UPDATE_RETURN_TO_URL = 'UPDATE_RETURN_TO_URL';
var USER_ID_CHANGE = exports.USER_ID_CHANGE = 'USER_ID_CHANGE';

// ===============
//  POST MESSAGE
// ===============

var POST_TO_PARENT = exports.POST_TO_PARENT = 'POST_TO_PARENT';
var REGISTER_MESSAGE_SUBJECT = exports.REGISTER_MESSAGE_SUBJECT = 'quizzesNext.register';
var SUBMISSION_CHANGE_SUBJECT = exports.SUBMISSION_CHANGE_SUBJECT = 'canvas.speedGraderSubmissionChange';
var SUBMISSION_UPDATE_SUBJECT = exports.SUBMISSION_UPDATE_SUBJECT = 'quizzesNext.submissionUpdate';

// ===============
//     FEATURES
// ===============

var ADD_FEATURES = exports.ADD_FEATURES = 'ADD_FEATURES';
var REMOVE_FEATURES = exports.REMOVE_FEATURES = 'REMOVE_FEATURES';

// ===============
//    DATA KEYS
// ===============

var RETURN_TO_URL_QUERY_KEY = exports.RETURN_TO_URL_QUERY_KEY = 'return_to';
var RETURN_TO_URL_STORAGE_KEY = exports.RETURN_TO_URL_STORAGE_KEY = 'return_to_url';

// ===============
//   QTI IMPORTS
// ===============

var ADD_QTI_IMPORTS = exports.ADD_QTI_IMPORTS = 'ADD_QTI_IMPORTS';
var CLEAR_QTI_IMPORTS = exports.CLEAR_QTI_IMPORTS = 'CLEAR_QTI_IMPORTS';
var CREATE_QTI_IMPORT = exports.CREATE_QTI_IMPORT = 'CREATE_QTI_IMPORT';

// ===============
//     ALERTS
// ===============

var ADD_ALERT = exports.ADD_ALERT = 'ADD_ALERT';
var DEFAULT_ALERT_TIME = exports.DEFAULT_ALERT_TIME = 5000;
var REMOVE_ALERT = exports.REMOVE_ALERT = 'REMOVE_ALERT';

// ===============
//  DRAG AND DROP
// ===============

var HOVER_POSITION = exports.HOVER_POSITION = 'HOVER_POSITION';
var QUIZ_ENTRY_REF = exports.QUIZ_ENTRY_REF = 'quiz_entry';
var SIDEBAR_ITEM_REF = exports.SIDEBAR_ITEM_REF = 'sidebar_item';

// ===============
//     MODAL
// ===============
var CLOSE_MODAL = exports.CLOSE_MODAL = 'CLOSE_MODAL';
var IMPORT_MODAL = exports.IMPORT_MODAL = 'IMPORT_MODAL';
var IMPORTING_MODAL = exports.IMPORTING_MODAL = 'IMPORTING_MODAL';
var OPEN_MODAL = exports.OPEN_MODAL = 'OPEN_MODAL';
var OPEN_ADD_CONTENT_MODAL = exports.OPEN_ADD_CONTENT_MODAL = 'OPEN_ADD_CONTENT_MODAL';
var OPEN_ADD_CONTENT_MODAL_DATA = exports.OPEN_ADD_CONTENT_MODAL_DATA = 'OPEN_ADD_CONTENT_MODAL_DATA';
var ADD_CONTENT_MODAL = exports.ADD_CONTENT_MODAL = 'ADD_CONTENT_MODAL';
var UPLOAD_ERROR_MODAL = exports.UPLOAD_ERROR_MODAL = 'UPLOAD_ERROR_MODAL';
var CREATE_BANK_MODAL = exports.CREATE_BANK_MODAL = 'CREATE_BANK_MODAL';
var EDIT_BANK_MODAL = exports.EDIT_BANK_MODAL = 'EDIT_BANK_MODAL';
var ADD_TO_BANK_MODAL = exports.ADD_TO_BANK_MODAL = 'ADD_TO_BANK_MODAL';
var ADD_TO_BANK_MODAL_BANK_SELECTION = exports.ADD_TO_BANK_MODAL_BANK_SELECTION = 'ADD_TO_BANK_MODAL_BANK_SELECTION';
var COPY_MOVE_BANK_ENTRY_MODAL = exports.COPY_MOVE_BANK_ENTRY_MODAL = 'COPY_MOVE_BANK_ENTRY_MODAL';
var COPY_MOVE_BANK_ENTRY_MODAL_BANK_SELECTION = exports.COPY_MOVE_BANK_ENTRY_MODAL_BANK_SELECTION = 'COPY_MOVE_BANK_ENTRY_MODAL_BANK_SELECTION';
var COPY_MOVE_BANK_ENTRY_MODAL_KEEP_COPY = exports.COPY_MOVE_BANK_ENTRY_MODAL_KEEP_COPY = 'COPY_MOVE_BANK_ENTRY_MODAL_KEEP_COPY';
var ITEM_FEEDBACK_MODAL = exports.ITEM_FEEDBACK_MODAL = 'ITEM_FEEDBACK_MODAL';
var ITEM_FEEDBACK_MODAL_ITEM = exports.ITEM_FEEDBACK_MODAL_ITEM = 'ITEM_FEEDBACK_MODAL_ITEM';
var ITEM_FEEDBACK_MODAL_FEEDBACK = exports.ITEM_FEEDBACK_MODAL_FEEDBACK = 'ITEM_FEEDBACK_MODAL_FEEDBACK';
var ADD_BANK_ENTRY_MODAL = exports.ADD_BANK_ENTRY_MODAL = 'ADD_BANK_ENTRY_MODAL';
var DELETE_STIMULUS_MODAL = exports.DELETE_STIMULUS_MODAL = 'DELETE_STIMULUS_MODAL';
var OPEN_DELETE_STIMULUS_MODAL = exports.OPEN_DELETE_STIMULUS_MODAL = 'OPEN_DELETE_STIMULUS_MODAL';
var DELETE_STIMULUS_DATA = exports.DELETE_STIMULUS_DATA = 'DELETE_STIMULUS_DATA';
var DELETE_STIMULUS_MODAL_SELECTED_CHILDREN = exports.DELETE_STIMULUS_MODAL_SELECTED_CHILDREN = 'DELETE_STIMULUS_MODAL_SELECTED_CHILDREN';
var DELETE_STIMULUS_MODAL_DELETION_MODE = exports.DELETE_STIMULUS_MODAL_DELETION_MODE = 'DELETE_STIMULUS_MODAL_DELETION_MODE';
var MOVE_IMMUTABLE_MODAL = exports.MOVE_IMMUTABLE_MODAL = 'MOVE_IMMUTABLE_MODAL';
var OPEN_MOVE_IMMUTABLE_MODAL = exports.OPEN_MOVE_IMMUTABLE_MODAL = 'OPEN_MOVE_IMMUTABLE_MODAL';
var MOVE_IMMUTABLE_DATA = exports.MOVE_IMMUTABLE_DATA = 'MOVE_IMMUTABLE_DATA';
var PARENT_TYPE_QUIZ = exports.PARENT_TYPE_QUIZ = 'PARENT_TYPE_QUIZ';
var PARENT_TYPE_BANK = exports.PARENT_TYPE_BANK = 'PARENT_TYPE_BANK';
var PARENT_TYPE_QUIZ_SESSION = exports.PARENT_TYPE_QUIZ_SESSION = 'PARENT_TYPE_QUIZ_SESSION';
var REGRADE_MODAL = exports.REGRADE_MODAL = 'REGRADE_MODAL';

// ===================
//     FILE UPLOAD
// ===================
var CLEAR_ALT_TEXT = exports.CLEAR_ALT_TEXT = 'CLEAR_ALT_TEXT';
var CLEAR_FILES = exports.CLEAR_FILES = 'CLEAR_FILES';
var FILE_RECEIVED = exports.FILE_RECEIVED = 'FILE_RECEIVED';
var FILE_UPLOAD_STATUS = exports.FILE_UPLOAD_STATUS = 'FILE_UPLOAD_STATUS';
var FILE_UPLOAD_SELECT = exports.FILE_UPLOAD_SELECT = 'FILE_UPLOAD_SELECT';
var FILE_UPLOAD_IMPORTING = exports.FILE_UPLOAD_IMPORTING = 'FILE_UPLOAD_IMPORTING';
var FILE_UPLOAD_SUCCESS = exports.FILE_UPLOAD_SUCCESS = 'FILE_UPLOAD_SUCCESS';
var FILE_UPLOAD_FAILURE = exports.FILE_UPLOAD_FAILURE = 'FILE_UPLOAD_FAILURE';
var FILE_UPLOAD_ERROR = exports.FILE_UPLOAD_ERROR = 'FILE_UPLOAD_ERROR';
var SET_ALT_TEXT = exports.SET_ALT_TEXT = 'SET_ALT_TEXT';

// ===============
//     ERRORS
// ===============

var CLEAR_ERRORS_SHOWING = exports.CLEAR_ERRORS_SHOWING = 'CLEAR_ERRORS_SHOWING';
var HIDE_ERROR = exports.HIDE_ERROR = 'HIDE_ERROR';
var SHOW_ERROR = exports.SHOW_ERROR = 'SHOW_ERROR';

// =======================
//    HTTP STATUS CODES
// =======================

var HTTP_STATUS_CODE_UNAUTHORIZED = exports.HTTP_STATUS_CODE_UNAUTHORIZED = 401;

// ===============
//     EDITING
// ===============

var START_EDIT = exports.START_EDIT = 'START_EDIT';
var END_EDIT = exports.END_EDIT = 'END_EDIT';
var TOGGLE_EDIT = exports.TOGGLE_EDIT = 'TOGGLE_EDIT';

// ===============
//     SIDEBAR
// ===============

var SIDEBAR_OPEN = exports.SIDEBAR_OPEN = 'SIDEBAR_OPEN';
var SIDEBAR_CLOSE = exports.SIDEBAR_CLOSE = 'SIDEBAR_CLOSE';
var TOGGLE_SIDEBAR = exports.TOGGLE_SIDEBAR = 'TOGGLE_SIDEBAR';
var SCROLL_TO_COMPONENT = exports.SCROLL_TO_COMPONENT = 'SCROLL_TO_COMPONENT';
var CLEAR_SCROLLED_COMPONENT = exports.CLEAR_SCROLLED_COMPONENT = 'CLEAR_SCROLLED_COMPONENT';
var SCROLL_HIGHLIGHT_TIME = exports.SCROLL_HIGHLIGHT_TIME = 3000;
var SET_SIDEBAR_STIMULUS_IS_SHOWING = exports.SET_SIDEBAR_STIMULUS_IS_SHOWING = 'SET_SIDEBAR_STIMULUS_IS_SHOWING';

// ===============
//     SEARCH
// ===============

var BANKS_TOGGLE_INTERACTIONS_KEY = exports.BANKS_TOGGLE_INTERACTIONS_KEY = 'BankSearch.toggleInteractions';
var BANKS_SEARCH_FILTER_KEY = exports.BANKS_SEARCH_FILTER_KEY = 'BankSearch.toggleFilters';
var SEARCH_RESET = exports.SEARCH_RESET = 'SEARCH_RESET';
var SEARCH_UPDATE = exports.SEARCH_UPDATE = 'SEARCH_UPDATE';
var SEARCH_TOGGLE = exports.SEARCH_TOGGLE = 'SEARCH_TOGGLE';

// ===============
//     QUIZZES
// ===============

var PERSIST_MODIFICATION = exports.PERSIST_MODIFICATION = 'PERSIST_MODIFICATION';
var FETCH_QUIZZES = exports.FETCH_QUIZZES = 'FETCH_QUIZZES';
var ADD_QUIZZES = exports.ADD_QUIZZES = 'ADD_QUIZZES';
var ASSOCIATE_QUIZ_ENTRIES = exports.ASSOCIATE_QUIZ_ENTRIES = 'ASSOCIATE_QUIZ_ENTRIES';
var DISASSOCIATE_QUIZ_ENTRY = exports.DISASSOCIATE_QUIZ_ENTRY = 'DISASSOCIATE_QUIZ_ENTRY';
var ASSOCIATE_ITEM_ANALYSES = exports.ASSOCIATE_ITEM_ANALYSES = 'ASSOCIATE_ITEM_ANALYSES';
var ASSOCIATE_QUIZ_ANALYSIS = exports.ASSOCIATE_QUIZ_ANALYSIS = 'ASSOCIATE_QUIZ_ANALYSIS';

// =========
//   ITEMS
// =========

var NEW_ITEM = exports.NEW_ITEM = 'NEW_ITEM';
var ADD_ITEMS = exports.ADD_ITEMS = 'ADD_ITEMS';
var LOAD_ITEMS = exports.LOAD_ITEMS = 'LOAD_ITEMS';
var REQUEST_ITEMS = exports.REQUEST_ITEMS = 'REQUEST_ITEMS';
var ITEMS_LOADING_ON = exports.ITEMS_LOADING_ON = 'ITEMS_LOADING_ON';
var ITEMS_LOADING_OFF = exports.ITEMS_LOADING_OFF = 'ITEMS_LOADING_OFF';
var SHOULD_CLONE_ITEM = exports.SHOULD_CLONE_ITEM = 'SHOULD_CLONE_ITEM';

// ===========
//   STIMULI
// ===========

var ADD_STIMULI = exports.ADD_STIMULI = 'ADD_STIMULI';

// ===========
//   QUIZ ENTRY REGRADES
// ===========

var CREATE_QUIZ_ENTRY_REGRADE = exports.CREATE_QUIZ_ENTRY_REGRADE = 'CREATE_QUIZ_ENTRY_REGRADE';
var REGRADE_SCORE_RECONCILIATION_SELECT_EXPANDED = exports.REGRADE_SCORE_RECONCILIATION_SELECT_EXPANDED = 'REGRADE_SCORE_RECONCILIATION_SELECT_EXPANDED';
var REGRADE_SET_PAYLOAD = exports.REGRADE_SET_PAYLOAD = 'REGRADE_SET_PAYLOAD';
var REGRADE_SET_SCORE_RECONCILIATION = exports.REGRADE_SET_SCORE_RECONCILIATION = 'REGRADE_SET_SCORE_RECONCILIATION';
var REGRADE_TOGGLE_REGRADING_EDIT_MODE = exports.REGRADE_TOGGLE_REGRADING_EDIT_MODE = 'REGRADE_TOGGLE_REGRADING_EDIT_MODE';

// =======================
//   QUIZ ENTRIES
// =======================

var OCCLUDE_QUIZ_ENTRIES = exports.OCCLUDE_QUIZ_ENTRIES = 'OCCLUDE_QUIZ_ENTRIES';
var ADD_QUIZ_ENTRIES = exports.ADD_QUIZ_ENTRIES = 'ADD_QUIZ_ENTRIES';
var ADD_QUIZ_ENTRY = exports.ADD_QUIZ_ENTRY = 'ADD_QUIZ_ENTRY';
var DELETE_QUIZ_ENTRY = exports.DELETE_QUIZ_ENTRY = 'DELETE_QUIZ_ENTRY';
var DELETE_STIMULUS_ENTRY = exports.DELETE_STIMULUS_ENTRY = 'DELETE_STIMULUS_ENTRY';
var MOVE_QUIZ_ENTRY = exports.MOVE_QUIZ_ENTRY = 'MOVE_QUIZ_ENTRY';
var QUIZ_ENTRY_GUID_SUFFIX = exports.QUIZ_ENTRY_GUID_SUFFIX = 'QUIZ_ENTRY_BUILD';

// ===============
//    QUIZ SESSIONS
// ===============
var ADD_QUIZ_SESSIONS = exports.ADD_QUIZ_SESSIONS = 'ADD_QUIZ_SESSIONS';

// ========================
//   QUIZ SESSION STATUSES
// ========================
var AUTOGRADING = exports.AUTOGRADING = 'autograding';
var CREATING_RESPONSES = exports.CREATING_RESPONSES = 'creating_responses';
var CREATING_SESSION_ITEMS = exports.CREATING_SESSION_ITEMS = 'creating_session_items';
var FAILED_TO_START = exports.FAILED_TO_START = 'failed_to_start';
var FAILURE = exports.FAILURE = 'failure';
var GRADED = exports.GRADED = 'graded';
var IN_PROGRESS = exports.IN_PROGRESS = 'in_progress';
var NEEDS_GRADING = exports.NEEDS_GRADING = 'needs_grading';
var PENDING = exports.PENDING = 'pending';
var STARTING = exports.STARTING = 'starting';

// ===============
//    QUIZ SESSION EVENTS
// ===============
var ADD_QUIZ_SESSION_EVENTS = exports.ADD_QUIZ_SESSION_EVENTS = 'ADD_QUIZ_SESSION_EVENTS';
var UPDATE_TIMER_INFO = exports.UPDATE_TIMER_INFO = 'UPDATE_TIMER_INFO';
var UPDATE_IS_TAKING = exports.UPDATE_IS_TAKING = 'UPDATE_IS_TAKING';
var UPDATE_TIMER_MINIMIZED = exports.UPDATE_TIMER_MINIMIZED = 'UPDATE_TIMER_MINIMIZED';
var UPDATE_QUIZ_SESSION_STATUS_ON_PAGE_LOAD = exports.UPDATE_QUIZ_SESSION_STATUS_ON_PAGE_LOAD = 'UPDATE_QUIZ_SESSION_STATUS_ON_PAGE_LOAD';

// =========================
//    QUIZ SESSION RESULTS
// =========================
var ACTIVE_QUESTION = exports.ACTIVE_QUESTION = 'ACTIVE_QUESTION';
var ADD_QUIZ_SESSION_RESULTS = exports.ADD_QUIZ_SESSION_RESULTS = 'ADD_QUIZ_SESSION_RESULTS';
var CACHED_SESSION_ID = exports.CACHED_SESSION_ID = 'CACHED_SESSION_ID';

// ===============
//    SESSION ITEMS
// ===============
var ADD_SESSION_ITEMS = exports.ADD_SESSION_ITEMS = 'ADD_SESSION_ITEMS';

// =========================
//    SESSION ITEM RESULTS
// =========================
var ADD_SESSION_ITEM_RESULTS = exports.ADD_SESSION_ITEM_RESULTS = 'ADD_SESSION_ITEM_RESULTS';

// ==========================
//   SESSION ITEM RESPONSE
// ==========================
var ADD_SESSION_ITEM_RESPONSES = exports.ADD_SESSION_ITEM_RESPONSES = 'ADD_SESSION_ITEM_RESPONSES';

// ===============
//    RESPONSES
// ===============

var LOAD_RESUME_DATA = exports.LOAD_RESUME_DATA = 'LOAD_RESUME_DATA';
var PREVIEW_RESPONSE = exports.PREVIEW_RESPONSE = 'PREVIEW_RESPONSE';

// ==============================
//    EVENT GENERATING THINGS
// ==============================

var QUIZ_SUBMISSION_EVENT = exports.QUIZ_SUBMISSION_EVENT = 'QUIZ_SUBMISSION_EVENT';
var UPDATE_QUIZ_SUBMIT_FLAG = exports.UPDATE_QUIZ_SUBMIT_FLAG = 'UPDATE_QUIZ_SUBMIT_FLAG';
var RESPONSE = exports.RESPONSE = 'RESPONSE';
var SESSION_STARTED_OR_RESUMED_EVENT = exports.SESSION_STARTED_OR_RESUMED_EVENT = 'SESSION_STARTED_OR_RESUMED_EVENT';

// ==================
//   MODIFICATIONS
// ==================

var CLEAR_TEMPORARY_ITEM = exports.CLEAR_TEMPORARY_ITEM = 'CLEAR_TEMPORARY_ITEM';
var CLEAR_TEMPORARY_BANK_ITEM = exports.CLEAR_TEMPORARY_BANK_ITEM = 'CLEAR_TEMPORARY_BANK_ITEM';
var CLEAR_TEMPORARY_STIMULUS = exports.CLEAR_TEMPORARY_STIMULUS = 'CLEAR_TEMPORARY_STIMULUS';
var CREATE_TEMPORARY_ITEM = exports.CREATE_TEMPORARY_ITEM = 'CREATE_TEMPORARY_ITEM';
var CREATE_TEMPORARY_BANK_ITEM = exports.CREATE_TEMPORARY_BANK_ITEM = 'CREATE_TEMPORARY_BANK_ITEM';
var MOVE_TEMPORARY_ITEM = exports.MOVE_TEMPORARY_ITEM = 'MOVE_TEMPORARY_ITEM';
var TEMPORARY_ITEM_ID = exports.TEMPORARY_ITEM_ID = 'TEMPORARY_ITEM';
var TEMPORARY_QUIZ_ENTRY_ID = exports.TEMPORARY_QUIZ_ENTRY_ID = 'TEMPORARY_QUIZ_ENTRY';
var TEMPORARY_BANK_ENTRY_ID = exports.TEMPORARY_BANK_ENTRY_ID = 'TEMPORARY_BANK_ENTRY';
var TEMPORARY_STIMULUS_ID = exports.TEMPORARY_STIMULUS_ID = 'TEMPORARY_STIMULUS';
var SET_NEXT_QUIZ_ENTRY = exports.SET_NEXT_QUIZ_ENTRY = 'SET_NEXT_QUIZ_ENTRY';
var CLEAR_NEXT_QUIZ_ENTRY = exports.CLEAR_NEXT_QUIZ_ENTRY = 'CLEAR_NEXT_QUIZ_ENTRY';

var CLEAR_MODIFICATIONS = exports.CLEAR_MODIFICATIONS = 'CLEAR_MODIFICATIONS';
var ITEM_MODIFICATION = exports.ITEM_MODIFICATION = 'ITEM_MODIFICATION';
var QUIZ_ENTRIES_MODIFICATION = exports.QUIZ_ENTRIES_MODIFICATION = 'QUIZ_ENTRIES_MODIFICATION';
var QUIZ_MODIFICATION = exports.QUIZ_MODIFICATION = 'QUIZ_MODIFICATION';
var BANK_MODIFICATION = exports.BANK_MODIFICATION = 'BANK_MODIFICATION';
var QUIZ_SESSION_RESULT_MODIFICATION = exports.QUIZ_SESSION_RESULT_MODIFICATION = 'QUIZ_SESSION_RESULT_MODIFICATION';
var SESSION_ITEM_RESULTS_MODIFICATION = exports.SESSION_ITEM_RESULTS_MODIFICATION = 'SESSION_ITEM_RESULTS_MODIFICATION';
var STIMULUS_MODIFICATION = exports.STIMULUS_MODIFICATION = 'STIMULUS_MODIFICATION';

var CREATE_TEMPORARY_BANK = exports.CREATE_TEMPORARY_BANK = 'CREATE_TEMPORARY_BANK';

var CREATE_TEMPORARY_STIMULUS = exports.CREATE_TEMPORARY_STIMULUS = 'CREATE_TEMPORARY_STIMULUS';

// =======================
//    INTERACTION TYPES
// =======================

var ADD_INTERACTION_TYPES = exports.ADD_INTERACTION_TYPES = 'ADD_INTERACTION_TYPES';
var FORMULA_SLUG = exports.FORMULA_SLUG = 'formula';

// =======================
//    ITEM BANKING
// =======================

var ADD_BANKS = exports.ADD_BANKS = 'ADD_BANKS';
var SET_BANK_FILTERS = exports.SET_BANK_FILTERS = 'SET_BANK_FILTERS';
var ADD_BANK_ENTRIES = exports.ADD_BANK_ENTRIES = 'ADD_BANK_ENTRIES';
var ARCHIVE_BANK_ENTRY = exports.ARCHIVE_BANK_ENTRY = 'ARCHIVE_BANK_ENTRY';
var ARCHIVE_BANK = exports.ARCHIVE_BANK = 'ARCHIVE_BANK';
var ASSOCIATE_ENTRIES = exports.ASSOCIATE_ENTRIES = 'ASSOCIATE_ENTRIES';
var DISASSOCIATE_ENTRY = exports.DISASSOCIATE_ENTRY = 'DISASSOCIATE_ENTRY';
var TEMPORARY_BANK_ID = exports.TEMPORARY_BANK_ID = 'TEMPORARY_BANK';
var BUILD_TRAY_OPEN = exports.BUILD_TRAY_OPEN = 'BUILD_TRAY_OPEN';
var TRAY_ALERT_OPEN = exports.TRAY_ALERT_OPEN = 'TRAY_ALERT_OPEN';
var BUILD_TRAY_POSITION = exports.BUILD_TRAY_POSITION = 'BUILD_TRAY_POSITION';
var BUILD_TRAY_STIMULUS_ID = exports.BUILD_TRAY_STIMULUS_ID = 'BUILD_TRAY_STIMULUS_ID';
var BUILD_TRAY_BUTTON_REF = exports.BUILD_TRAY_BUTTON_REF = 'BUILD_TRAY_BUTTON_REF';
var SET_EDIT_BUTTON_FOCUS = exports.SET_EDIT_BUTTON_FOCUS = 'SET_EDIT_BUTTON_FOCUS';
var ADD_BANK_TO_QUIZ = exports.ADD_BANK_TO_QUIZ = 'ADD_BANK_TO_QUIZ';
var ADD_BANK_TO_QUIZ_SAMPLE_NUM = exports.ADD_BANK_TO_QUIZ_SAMPLE_NUM = 'ADD_BANK_TO_QUIZ_SAMPLE_NUM';
var ADD_BANK_TO_QUIZ_POINTS_POSSIBLE = exports.ADD_BANK_TO_QUIZ_POINTS_POSSIBLE = 'ADD_BANK_TO_QUIZ_POINTS_POSSIBLE';
var ADD_BANK_TO_QUIZ_ALL_OR_RAND = exports.ADD_BANK_TO_QUIZ_ALL_OR_RAND = 'ADD_BANK_TO_QUIZ_ALL_OR_RAND';
var GET_BANK_ENTRIES_CALL = exports.GET_BANK_ENTRIES_CALL = 'GET_BANK_ENTRIES_CALL';
var GET_BANK_ENTRY_CALL = exports.GET_BANK_ENTRY_CALL = 'GET_BANK_ENTRY_CALL';
var UPDATE_BANK_ENTRY_CALL = exports.UPDATE_BANK_ENTRY_CALL = 'UPDATE_BANK_ENTRY_CALL';
var CREATE_BANK_ENTRY_CALL = exports.CREATE_BANK_ENTRY_CALL = 'CREATE_BANK_ENTRY_CALL';
var UPDATE_BANK_CALL = exports.UPDATE_BANK_CALL = 'UPDATE_BANK_CALL';
var REMOVE_BANK_ENTRY_CALL = exports.REMOVE_BANK_ENTRY_CALL = 'REMOVE_BANK_ENTRY_CALL';
var SELECT_BANKS_OPTIONS = exports.SELECT_BANKS_OPTIONS = 'SELECT_BANKS_OPTIONS';
var DELETE_BANK_CALL = exports.DELETE_BANK_CALL = 'DELETE_BANK_CALL';
var REMOVE_BANK = exports.REMOVE_BANK = 'REMOVE_BANK';
var ADD_SHARED_BANKS = exports.ADD_SHARED_BANKS = 'ADD_SHARED_BANKS';
var UPDATE_SHARED_BANK = exports.UPDATE_SHARED_BANK = 'UPDATE_SHARED_BANK';
var REMOVE_SHARED_BANK = exports.REMOVE_SHARED_BANK = 'REMOVE_SHARED_BANK';

// =======================
//    TAG ASSOCIATIONS
// =======================

// Name of Redux action that adds a tag to a given entity
var ADD_TAG_ASSOCIATIONS = exports.ADD_TAG_ASSOCIATIONS = 'ADD_TAG_ASSOCIATIONS';
// Name of fetcher call type when fetching item tags
var GET_ITEM_TAG_ASSOCIATIONS = exports.GET_ITEM_TAG_ASSOCIATIONS = 'GET_ITEM_TAG_ASSOCIATIONS';
// Name of fetcher call type when fetching stimulus tags
var GET_STIMULUS_TAG_ASSOCIATIONS = exports.GET_STIMULUS_TAG_ASSOCIATIONS = 'GET_STIMULUS_TAG_ASSOCIATIONS';

// Name of Redux action that removes a tag from a given entity
var REMOVE_TAG_ASSOCIATION = exports.REMOVE_TAG_ASSOCIATION = 'REMOVE_TAG_ASSOCIATION';
// Name of fetcher call type when deleting a tag association
var DELETE_TAG_ASSOCIATION = exports.DELETE_TAG_ASSOCIATION = 'DELETE_TAG_ASSOCIATION';

// Name of Redux action that sets pending tag deletions from a given entity
var SET_PENDING_DELETION_TAG_ASSOCIATIONS = exports.SET_PENDING_DELETION_TAG_ASSOCIATIONS = 'SET_PENDING_DELETION_TAG_ASSOCIATIONS';
// Name of Redux action that gets pending tag deletions for a given entity
var GET_PENDING_DELETION_TAG_ASSOCIATIONS = exports.GET_PENDING_DELETION_TAG_ASSOCIATIONS = 'GET_PENDING_DELETION_TAG_ASSOCIATIONS';

// =======================
//    MATCHING COMPONENTS
// =======================

var MATCH_LIST = exports.MATCH_LIST = 'matchList';
var CATEGORIES = exports.CATEGORIES = 'categories';

// ================
//    MODERATION
// ================

var CLOSE_MODERATE_TRAY = exports.CLOSE_MODERATE_TRAY = 'CLOSE_MODERATE_TRAY';
var MODERATE_TRAY_CLOSED = exports.MODERATE_TRAY_CLOSED = 'MODERATE_TRAY_CLOSED';
var OPEN_MODERATE_TRAY = exports.OPEN_MODERATE_TRAY = 'OPEN_MODERATE_TRAY';

// ===============
//     UI STATE
// ===============

var CLEAR_UI = exports.CLEAR_UI = 'CLEAR_UI';
var MERGE_UI = exports.MERGE_UI = 'MERGE_UI';
var SET_UI = exports.SET_UI = 'SET_UI';
var TOGGLE_UI = exports.TOGGLE_UI = 'TOGGLE_UI';
var MODERATE_QUIZ_SESSION_PAGINATION = exports.MODERATE_QUIZ_SESSION_PAGINATION = 'MODERATE_QUIZ_SESSION_PAGINATION';
var BANKS_BANK_PAGINATION = exports.BANKS_BANK_PAGINATION = 'BANKS_BANK_PAGINATION';
var BANKS_BANK_ENTRY_PAGINATION = exports.BANKS_BANK_ENTRY_PAGINATION = 'BANKS_BANK_ENTRY_PAGINATION';
var STUDENT_ACCESS_CODE_VALUE = exports.STUDENT_ACCESS_CODE_VALUE = 'STUDENT_ACCESS_CODE_VALUE';
var STUDENT_ACCESS_CODE_STATUS = exports.STUDENT_ACCESS_CODE_STATUS = 'STUDENT_ACCESS_CODE_STATUS';
var DELETED_QUIZ_ENTRY = exports.DELETED_QUIZ_ENTRY = 'DELETED_QUIZ_ENTRY';
var MOVED_QUIZ_ENTRY = exports.MOVED_QUIZ_ENTRY = 'MOVED_QUIZ_ENTRY';
var MOVED_IN_SIDEBAR = exports.MOVED_IN_SIDEBAR = 'MOVED_IN_SIDEBAR';

// ===============
//     CALLS
// ===============

var CALL_STATUS = exports.CALL_STATUS = 'CALL_STATUS';
var CLONE_QUIZ_ENTRY_CALL = exports.CLONE_QUIZ_ENTRY_CALL = 'CLONE_QUIZ_ENTRY_CALL';
var CREATE_ITEM_CALL = exports.CREATE_ITEM_CALL = 'CREATE_ITEM_CALL';
var CREATE_QUIZ_ENTRY_CALL = exports.CREATE_QUIZ_ENTRY_CALL = 'CREATE_QUIZ_ENTRY_CALL';
var CREATE_STIMULUS_CALL = exports.CREATE_STIMULUS_CALL = 'CREATE_STIMULUS_CALL';
var DELETE_QUIZ_ENTRY_CALL = exports.DELETE_QUIZ_ENTRY_CALL = 'DELETE_QUIZ_ENTRY_CALL';
var FILE_UPLOAD_CALL = exports.FILE_UPLOAD_CALL = 'FILE_UPLOAD_CALL';
var FILE_UPLOAD_URL_CALL = exports.FILE_UPLOAD_URL_CALL = 'FILE_UPLOAD_URL_CALL';
var GRADING_INFO_CALL = exports.GRADING_INFO_CALL = 'GRADING_INFO_CALL';
var MOVE_QUIZ_ENTRY_CALL = exports.MOVE_QUIZ_ENTRY_CALL = 'MOVE_QUIZ_ENTRY_CALL';
var OQAAT_NO_BACKTRACKING_NEXT_ITEM_FETCH_CALL = exports.OQAAT_NO_BACKTRACKING_NEXT_ITEM_FETCH_CALL = 'OQAAT_NO_BACKTRACKING_NEXT_ITEM_FETCH_CALL';
var QUIZ_SAVE_CALL = exports.QUIZ_SAVE_CALL = 'QUIZ_SAVE_CALL';
var QUIZ_SESSIONS_FETCH_CALL = exports.QUIZ_SESSIONS_FETCH_CALL = 'QUIZ_SESSIONS_FETCH_CALL';
var QUIZ_SESSION_EVENTS_FETCH_CALL = exports.QUIZ_SESSION_EVENTS_FETCH_CALL = 'QUIZ_SESSION_EVENTS_FETCH_CALL';
var QUIZ_SESSION_FETCH_CALL = exports.QUIZ_SESSION_FETCH_CALL = 'QUIZ_SESSION_FETCH_CALL';
var QUIZ_SESSION_RESULT_FETCH_CALL = exports.QUIZ_SESSION_RESULT_FETCH_CALL = 'QUIZ_SESSION_RESULT_FETCH_CALL';
var QUIZ_SESSION_REOPEN_CALL = exports.QUIZ_SESSION_REOPEN_CALL = 'QUIZ_SESSION_REOPEN_CALL';
var QUIZ_SESSION_RESET_CALL = exports.QUIZ_SESSION_RESET_CALL = 'QUIZ_SESSION_RESET_CALL';
var SET_CALLBACKS_STATUS = exports.SET_CALLBACKS_STATUS = 'SET_CALLBACKS_STATUS';
var UPDATE_ITEM_CALL = exports.UPDATE_ITEM_CALL = 'UPDATE_ITEM_CALL';
var UPDATE_QUIZ_ENTRY_CALL = exports.UPDATE_QUIZ_ENTRY_CALL = 'UPDATE_QUIZ_ENTRY_CALL';
var UPDATE_STIMULUS_CALL = exports.UPDATE_STIMULUS_CALL = 'UPDATE_STIMULUS_CALL';
var SESSION_ITEMS_FETCH_CALL = exports.SESSION_ITEMS_FETCH_CALL = 'SESSION_ITEMS_FETCH_CALL';

// ===============
//    TAKING CALLS
// ===============

var BACKTRACKING_NEXT_QUESTION = exports.BACKTRACKING_NEXT_QUESTION = 'BACKTRACKING_NEXT_QUESTION';
var PREVIOUS_QUESTION = exports.PREVIOUS_QUESTION = 'PREVIOUS_QUESTION';
var SHOW_OR_RESUME_QUIZ = exports.SHOW_OR_RESUME_QUIZ = 'SHOW_OR_RESUME_QUIZ';
var START_QUIZ_CALL = exports.START_QUIZ_CALL = 'START_QUIZ_CALL';
var SUBMIT_QUIZ = exports.SUBMIT_QUIZ = 'SUBMIT_QUIZ';
var SET_CURRENT_SESSION_ITEM_POSITION = exports.SET_CURRENT_SESSION_ITEM_POSITION = 'SET_CURRENT_SESSION_ITEM_POSITION';

// =============
//    HELPERS
// =============

var DO_NOTHING = exports.DO_NOTHING = 'DO_NOTHING';

// =============
//    COMPONENT TYPES
// =============
var COMPONENT_EDIT = exports.COMPONENT_EDIT = 'EDIT';
var COMPONENT_SHOW = exports.COMPONENT_SHOW = 'SHOW';
var COMPONENT_TAKE = exports.COMPONENT_TAKE = 'TAKE';
var COMPONENT_RESULT = exports.COMPONENT_RESULT = 'RESULT';

// ==============
//    CONFIG
// ==============
var SET_API_ENDPOINT = exports.SET_API_ENDPOINT = 'SET_API_ENDPOINT';
var SET_USER_TOKEN = exports.SET_USER_TOKEN = 'SET_USER_TOKEN';

// ==============
//   QUIZ REPORTING ANALYTICS
// =============
var ADD_ITEM_ANALYSES = exports.ADD_ITEM_ANALYSES = 'ADD_ITEM_ANALYSES';
var ADD_QUIZ_ANALYSIS = exports.ADD_QUIZ_ANALYSIS = 'ADD_QUIZ_ANALYSIS';
var QUIZ_ANALYSIS_NOT_FOUND = exports.QUIZ_ANALYSIS_NOT_FOUND = 'QUIZ_ANALYSIS_NOT_FOUND';
var ITEM_ANALYSIS_NOT_FOUND = exports.ITEM_ANALYSIS_NOT_FOUND = 'ITEM_ANALYSIS_NOT_FOUND';
var TOGGLE_ITEM_ANALYSIS_EXPANDED = exports.TOGGLE_ITEM_ANALYSIS_EXPANDED = 'TOGGLE_ITEM_ANALYSIS_EXPANDED';

// =============
//   SKIP TO CONTENT
// =============
var SKIP_TO_CONTENT_FOCUS = exports.SKIP_TO_CONTENT_FOCUS = 'SKIP_TO_CONTENT_FOCUS';
var SKIP_TO_CONTENT_BLUR = exports.SKIP_TO_CONTENT_BLUR = 'SKIP_TO_CONTENT_BLUR';

// =============
//   OUTCOMES
// =============
var SET_CONTEXT_UUID = exports.SET_CONTEXT_UUID = 'SET_CONTEXT_UUID';
var SET_OUTCOMES_ENDPOINT = exports.SET_OUTCOMES_ENDPOINT = 'SET_OUTCOMES_ENDPOINT';
var SET_OUTCOMES_TOKEN = exports.SET_OUTCOMES_TOKEN = 'SET_OUTCOMES_TOKEN';

// ================
//   PERMISSIONS
// ================
var CAN_EDIT = exports.CAN_EDIT = 'edit';
var READ_ONLY = exports.READ_ONLY = 'read';
var REMOVED_ACCESS = exports.REMOVED_ACCESS = 'removed_access';

// ================
//   INST-UI STYLES
// ================
var XSMALL_SIDE_MARGIN = exports.XSMALL_SIDE_MARGIN = '0 x-small';

// ================
//   KEYS / IDs
// ================
var INSTRUCTIONS_EDIT_ID = exports.INSTRUCTIONS_EDIT_ID = 'instructionsEdit';
var ADD_CONTENT_POPOVER_KEY = exports.ADD_CONTENT_POPOVER_KEY = 'AddContentPopover';
var SIDEBAR_NAV_ID = exports.SIDEBAR_NAV_ID = 'quiz-react-sdk_sidebar-nav';
var REMOVE = exports.REMOVE = 'Remove';
var MOVE = exports.MOVE = 'Move';
var EDIT = exports.EDIT = 'Edit';

// ================
//   MISC
// ================
// dynamo supports 400 KB, so 390,000 characters should
// keep us safely in that limit
var BUILD_CHAR_LIMIT = exports.BUILD_CHAR_LIMIT = 390000;
// Take limit is half of Build since userResponse is
// duplicated in statistics_data for the session_item_response
var TAKE_CHAR_LIMIT = exports.TAKE_CHAR_LIMIT = 195000;