'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reactImmutableProptypes = require('react-immutable-proptypes');

var _reactImmutableProptypes2 = _interopRequireDefault(_reactImmutableProptypes);

var _IconMoveDownBottomLine = require('instructure-icons/lib/Line/IconMoveDownBottomLine');

var _IconMoveDownBottomLine2 = _interopRequireDefault(_IconMoveDownBottomLine);

var _Button = require('@instructure/ui-buttons/lib/components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _ScreenReaderContent = require('@instructure/ui-a11y/lib/components/ScreenReaderContent');

var _ScreenReaderContent2 = _interopRequireDefault(_ScreenReaderContent);

var _lib = require('@instructure/ui-themeable/lib');

var _lib2 = _interopRequireDefault(_lib);

var _RichContentRenderer = require('quiz-interactions/lib/components/common/components/rce/RichContentRenderer');

var _RichContentRenderer2 = _interopRequireDefault(_RichContentRenderer);

var _windowChecks = require('../../../../../../common/util/windowChecks');

var _formatMessage = require('../../../../../../common/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

var _makeScrollable = require('../../../../../../common/components/shared/functionality/makeScrollable');

var _makeScrollable2 = _interopRequireDefault(_makeScrollable);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  template: function template(theme) {
    return '/*  imported from styles.css  */\n\n.StimulusInfo__styles__info {\n  padding: ' + theme.infoPaddingTopBottom + ' ' + theme.infoPaddingLeftRight + ';\n  background-color: ' + theme.infoBackgroundColor + ';\n  height: 100%;\n}\n\n.StimulusInfo__styles__header {\n  padding-top: ' + theme.headerPaddingTop + ';\n  padding-bottom: ' + theme.headerPaddingBottom + ';\n  display: flex;\n  flex-direction: row;\n  justify-content: space-between;\n}\n\n.StimulusInfo__styles__title {\n  font-size: ' + theme.titleFontSize + ';\n  font-weight: ' + theme.titleFontWeight + ';\n}\n\n@media screen and (--phoneBreakPoint) {\n  .StimulusInfo__styles__info {\n    padding: ' + theme.phoneInfoPadding + ';\n  }\n}\n';
  },
  'info': 'StimulusInfo__styles__info',
  'header': 'StimulusInfo__styles__header',
  'title': 'StimulusInfo__styles__title'
};
var StimulusInfo = (_dec = (0, _lib2.default)(_theme2.default, styles), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(StimulusInfo, _Component);

  function StimulusInfo() {
    (0, _classCallCheck3.default)(this, StimulusInfo);
    return (0, _possibleConstructorReturn3.default)(this, (StimulusInfo.__proto__ || Object.getPrototypeOf(StimulusInfo)).apply(this, arguments));
  }

  (0, _createClass3.default)(StimulusInfo, [{
    key: 'renderJumpToItemsButton',
    value: function renderJumpToItemsButton() {
      if ((0, _windowChecks.onPhone)()) {
        return _react2.default.createElement(
          _Button2.default,
          { onClick: this.props.scrollToItems, icon: _IconMoveDownBottomLine2.default },
          _react2.default.createElement(
            _ScreenReaderContent2.default,
            null,
            '\u30A2\u30A4\u30C6\u30E0\u3092\u8868\u793A'
          )
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var stimulus = this.props.stimulus;

      return _react2.default.createElement(
        'div',
        { className: styles.info },
        _react2.default.createElement(
          'div',
          { className: styles.header },
          _react2.default.createElement(
            'div',
            { className: styles.title },
            stimulus.title
          ),
          this.renderJumpToItemsButton()
        ),
        _react2.default.createElement(_RichContentRenderer2.default, { content: stimulus.body })
      );
    }
  }]);
  StimulusInfo.displayName = 'StimulusInfo'
  ;
  return StimulusInfo;
}(_react.Component), _class2.propTypes = {
  stimulus: _reactImmutableProptypes2.default.record.isRequired,
  scrollToItems: _propTypes2.default.func.isRequired
}, _temp)) || _class);
exports.default = (0, _redux.compose)(_makeScrollable2.default)(StimulusInfo);