'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.uploadStatus = exports.setAltText = exports.receiveFile = exports.clearFiles = exports.clearAltText = undefined;

var _constants = require('../../constants');

var clearAltText = exports.clearAltText = function clearAltText() {
  return {
    type: _constants.CLEAR_ALT_TEXT
  };
};

var clearFiles = exports.clearFiles = function clearFiles() {
  return {
    type: _constants.CLEAR_FILES
  };
};

var receiveFile = exports.receiveFile = function receiveFile(file) {
  return {
    type: _constants.FILE_RECEIVED,
    payload: { file: file }
  };
};

var setAltText = exports.setAltText = function setAltText(altText) {
  return {
    type: _constants.SET_ALT_TEXT,
    payload: { altText: altText }
  };
};

var uploadStatus = exports.uploadStatus = function uploadStatus(status) {
  return {
    type: _constants.FILE_UPLOAD_STATUS,
    payload: { status: status }
  };
};