'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec,
    _class,
    _class2,
    _temp,
    _default_nl_number = Intl.NumberFormat('nl', { style: 'decimal' }).format;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Progress = require('@instructure/ui-elements/lib/components/Progress');

var _Progress2 = _interopRequireDefault(_Progress);

var _Text = require('@instructure/ui-elements/lib/components/Text');

var _Text2 = _interopRequireDefault(_Text);

var _lib = require('@instructure/ui-themeable/lib');

var _lib2 = _interopRequireDefault(_lib);

var _formatMessage = require('../../../../../common/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  template: function template(theme) {
    return '/*  imported from styles.css  */\n\n.TakeProgress__styles__root {\n  margin-top: ' + theme.rootMargin + ';\n\n  /* will look lopsided with the numeric value otherwise */\n  padding-left: ' + theme.rootPadding + ';\n}\n';
  },
  'root': 'TakeProgress__styles__root'
};
var TakeProgress = (_dec = (0, _lib2.default)(_theme2.default, styles), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(TakeProgress, _Component);

  function TakeProgress() {
    (0, _classCallCheck3.default)(this, TakeProgress);
    return (0, _possibleConstructorReturn3.default)(this, (TakeProgress.__proto__ || Object.getPrototypeOf(TakeProgress)).apply(this, arguments));
  }

  (0, _createClass3.default)(TakeProgress, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: styles.root },
        _react2.default.createElement(_Progress2.default, {
          size: 'small',
          label: 'Quiz Progress',
          formatValueText: this.formatValueText,
          formatDisplayedValue: this.formatDisplayValue,
          valueNow: this.props.currentQuestionPosition,
          valueMax: this.props.totalQuestionCount
        })
      );
    }
  }, {
    key: 'formatValueText',
    value: function formatValueText(valueNow, valueMax) {
      return _default_nl_number(valueNow) + ' van ' + _default_nl_number(valueMax) + ' vragen';
    }
  }, {
    key: 'formatDisplayValue',
    value: function formatDisplayValue(valueNow, valueMax) {
      var positionText = _default_nl_number(valueNow) + ' / ' + _default_nl_number(valueMax);
      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(
          _Text2.default,
          { size: 'small' },
          positionText
        )
      );
    }
  }]);
  TakeProgress.displayName = 'TakeProgress'
  ;
  return TakeProgress;
}(_react.Component), _class2.propTypes = {
  currentQuestionPosition: _propTypes2.default.number.isRequired,
  totalQuestionCount: _propTypes2.default.number.isRequired
}, _temp)) || _class);
exports.default = TakeProgress;