'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lib = require('@instructure/ui-themeable/lib');

var _lib2 = _interopRequireDefault(_lib);

var _Overlay = require('../../../../../../common/components/shared/overlay/Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  template: function template(theme) {
    return '/*  imported from styles.css  */\n\n.Show__styles__titleShowWrapper {\n  position: relative;\n  width: 100%;\n  height: 5rem;\n\n  border-bottom: ' + theme.titleShowWrapperBottomBorder + ';\n  box-sizing: border-box;\n\n  padding-left: ' + theme.titleShowWrapperLeftPadding + ';\n\n  display: flex;\n  flex-direction: column;\n  justify-content: center;\n}\n\n.Show__styles__titleShowText {\n  font-size: ' + theme.titleShowTextFontSize + ';\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n';
  },
  'titleShowWrapper': 'Show__styles__titleShowWrapper',
  'titleShowText': 'Show__styles__titleShowText'
};


// ====================================

// this component shows the quiz title
// has events that allow for toggling
// editing and hover which shows an
// overlay

// ====================================
var QuizTitleShow = (_dec = (0, _lib2.default)(_theme2.default, styles), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(QuizTitleShow, _Component);

  function QuizTitleShow() {
    (0, _classCallCheck3.default)(this, QuizTitleShow);
    return (0, _possibleConstructorReturn3.default)(this, (QuizTitleShow.__proto__ || Object.getPrototypeOf(QuizTitleShow)).apply(this, arguments));
  }

  (0, _createClass3.default)(QuizTitleShow, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _Overlay2.default,
        {
          wrapperClassName: styles.titleShowWrapper,
          onClick: this.props.switchOnEditing,
          tabIndex: '-1'
        },
        _react2.default.createElement(
          'span',
          { className: styles.titleShowText },
          this.props.defaultTitle
        )
      );
    }
  }]);
  QuizTitleShow.displayName = 'QuizTitleShow'
  ;
  return QuizTitleShow;
}(_react.Component), _class2.propTypes = {
  defaultTitle: _propTypes2.default.string.isRequired,
  switchOnEditing: _propTypes2.default.func.isRequired
}, _temp)) || _class);
exports.default = QuizTitleShow;