'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _redux = require('redux');

var _partial = require('lodash/partial');

var _partial2 = _interopRequireDefault(_partial);

var _reactRedux = require('../../../../../../common/react-redux');

var _ui = require('../../../../../../common/actions/ui');

var _constants = require('../../../../../../constants');

var _featureCheck = require('../../../../../../common/util/featureCheck');

var _makeScrollable = require('../../../../../../common/components/shared/functionality/makeScrollable');

var _makeScrollable2 = _interopRequireDefault(_makeScrollable);

var _presenter = require('./presenter');

var _presenter2 = _interopRequireDefault(_presenter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mapStateToProps(state, props) {
  return {
    contextUuid: state.getIn(['outcomes', 'contextUuid']),
    outcomesEndpoint: state.getIn(['outcomes', 'outcomesEndpoint']),
    outcomesToken: state.getIn(['outcomes', 'outcomesToken']),
    outcomeAlignmentsOn: (0, _featureCheck.featureOn)('outcome_alignments')
  };
}

function mapDispatchToProps(dispatch) {
  return {
    onItemBanksClick: (0, _redux.bindActionCreators)(_ui.set.bind(void 0, _constants.BUILD_TRAY_OPEN, true), dispatch),
    itemBanksButtonRef: (0, _redux.bindActionCreators)((0, _partial2.default)(_ui.set, _constants.BUILD_TRAY_BUTTON_REF), dispatch)
  };
}

exports.default = (0, _redux.compose)((0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps), _makeScrollable2.default)(_presenter2.default);