'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keyBy = require('lodash/keyBy');

var _keyBy2 = _interopRequireDefault(_keyBy);

var _immutable = require('immutable');

var _constants = require('../../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var addSessionItems = function addSessionItems(state, sessionItems) {
  var sessionItemsHash = (0, _keyBy2.default)(sessionItems, 'id');
  return state.mergeDeep((0, _immutable.fromJS)(sessionItemsHash));
};

var defaultState = (0, _immutable.fromJS)({});

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
  var action = arguments[1];

  switch (action.type) {
    case _constants.ADD_SESSION_ITEMS:
      return addSessionItems(state, action.payload);
    default:
      return state;
  }
};