'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactImmutableProptypes = require('react-immutable-proptypes');

var _reactImmutableProptypes2 = _interopRequireDefault(_reactImmutableProptypes);

var _IconOutcomesLine = require('instructure-icons/lib/Line/IconOutcomesLine');

var _IconOutcomesLine2 = _interopRequireDefault(_IconOutcomesLine);

var _Button = require('@instructure/ui-buttons/lib/components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Text = require('@instructure/ui-elements/lib/components/Text');

var _Text2 = _interopRequireDefault(_Text);

var _OutcomeCount = require('outcomes-react/lib/containers/OutcomeCount');

var _OutcomeCount2 = _interopRequireDefault(_OutcomeCount);

var _ScreenReaderContent = require('@instructure/ui-a11y/lib/components/ScreenReaderContent');

var _ScreenReaderContent2 = _interopRequireDefault(_ScreenReaderContent);

var _formatMessage = require('../../../../../../common/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

var _makeEditable = require('../../../../../../common/components/shared/functionality/makeEditable');

var _makeEditable2 = _interopRequireDefault(_makeEditable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OutcomesEditButton = (_temp = _class = function (_Component) {
  (0, _inherits3.default)(OutcomesEditButton, _Component);

  function OutcomesEditButton() {
    (0, _classCallCheck3.default)(this, OutcomesEditButton);
    return (0, _possibleConstructorReturn3.default)(this, (OutcomesEditButton.__proto__ || Object.getPrototypeOf(OutcomesEditButton)).apply(this, arguments));
  }

  (0, _createClass3.default)(OutcomesEditButton, [{
    key: 'variant',
    value: function variant() {
      return this.props.isEditing ? 'default' : 'light';
    }
  }, {
    key: 'statusText',
    value: function statusText() {
      if (this.props.isEditing) {
        return '\u7ED3\u679C\u9762\u677F\u5DF2\u6253\u5F00\uFF0C\u5355\u51FB\u53EF\u5173\u95ED';
      } else {
        return '\u7ED3\u679C\u9762\u677F\u5DF2\u5173\u95ED\uFF0C\u5355\u51FB\u53EF\u6253\u5F00';
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _Button2.default,
        {
          variant: this.variant(),
          onClick: this.props.toggleEditing,
          icon: _IconOutcomesLine2.default
        },
        _react2.default.createElement(
          _Text2.default,
          { size: 'small' },
          '\u7ED3\u679C',
          '\xA0',
          _react2.default.createElement(_OutcomeCount2.default, {
            artifactId: this.props.quiz.id,
            artifactType: 'quiz',
            alignmentSetId: this.props.quiz.outcomeAlignmentSetGuid,
            contextUuid: this.props.contextUuid,
            host: this.props.outcomesEndpoint,
            jwt: this.props.outcomesToken
          }),
          _react2.default.createElement(
            _ScreenReaderContent2.default,
            null,
            this.statusText()
          )
        )
      );
    }
  }]);
  OutcomesEditButton.displayName = 'OutcomesEditButton'
  ;
  return OutcomesEditButton;
}(_react.Component), _class.propTypes = {
  quiz: _reactImmutableProptypes2.default.record.isRequired,
  contextUuid: _propTypes2.default.string.isRequired,
  isEditing: _propTypes2.default.bool,
  toggleEditing: _propTypes2.default.func.isRequired,
  outcomesEndpoint: _propTypes2.default.string.isRequired,
  outcomesToken: _propTypes2.default.string.isRequired
}, _class.defaultProps = {
  isEditing: false
}, _temp);
exports.default = (0, _makeEditable2.default)(OutcomesEditButton);