'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.interactionTypeMetadata = undefined;

var _IconPlusLine = require('instructure-icons/lib/Line/IconPlusLine');

var _IconPlusLine2 = _interopRequireDefault(_IconPlusLine);

var _formatMessage = require('../format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO: Add correct icon file imports when they are in inst icons
// import MultipleChoiceIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import MultipleAnswerIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import TrueOrFalseIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import MatchingIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import OrderingIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import FillBlankIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import EssayIcon from 'instructure-icons/lib/Line/<insert icon name here>'
var interactionTypesIconDictionary = function interactionTypesIconDictionary(intType) {
  return {
    // TODO: Uncomment when we have the icons imported
    // 'choice': MultipleChoiceIcon,
    // 'multi-answer': MultipleAnswerIcon,
    // 'true-false': TrueOrFalseIcon,
    // 'matching': MatchingIcon,
    // 'ordering': OrderingIcon,
    // 'fill-blank': FillBlankIcon,
    // 'essay': EssayIcon
  }[intType.slug] || _IconPlusLine2.default;
};

var interactionTypesNameDictionary = function interactionTypesNameDictionary(intType) {
  return {
    categorization: '\u5206\u7C7B',
    choice: '\u591A\u9009',
    essay: '\u8BBA\u6587',
    'file-upload': '\u6587\u4EF6\u4E0A\u4F20',
    'fill-blank': '\u586B\u7A7A\u9898',
    formula: '\u516C\u5F0F',
    'hot-spot': '\u70ED\u70B9',
    matching: '\u5339\u914D',
    'multi-answer': '\u591A\u4E2A\u7B54\u6848',
    numeric: '\u6570\u5B57',
    ordering: '\u6392\u5E8F',
    'true-false': '\u5224\u65AD\u5BF9\u9519'
  }[intType.slug] || intType.name;
};

var interactionTypeMetadata = exports.interactionTypeMetadata = function interactionTypeMetadata(intType) {
  return {
    icon: interactionTypesIconDictionary(intType),
    name: interactionTypesNameDictionary(intType)
  };
};